#ifndef HITANAPROCESSOR_H
#define HITANAPROCESSOR_H

#include <marlin/Processor.h>
#include <lcio.h>
#include <string>
#include "TNtuple.h"
// Aida
#ifdef MARLIN_USE_AIDA
//AIDA
#include <marlin/AIDAProcessor.h>
#endif

namespace marlintpc
{
///  Short description of processor.

/**
 * Lengthy and detailed description of processor ...
 * @author Fn. Lastname, Affiliation
 *
 * \par Credits:
 * The processor skeleton was generated by the script \c createProcessor.py
 *
 */

class HitAnaProcessor : public marlin::Processor
{
 public:
  
  virtual Processor*  newProcessor() { return new HitAnaProcessor; }
  
  HitAnaProcessor();
  
  virtual void init();
  
  virtual void processRunHeader(lcio::LCRunHeader* run);
  
  virtual void processEvent(lcio::LCEvent* evt);
  
  virtual void check(lcio::LCEvent* evt);
  
  virtual void end();
  
  static bool padComp (const std::pair< double, double > & left, 
		       const std::pair< double, double > & right)
  {
    return( left.first < right.first );
  }
 
 protected:
  /* the place for protected and private member data and functions */
  std::string _inputColName; ///< Name of the input collection

  TNtuple * _tuple;

};
} // namespace marlintpc
#endif // HITANAPROCESSOR_H
