#!/bin/bash

if [ $# -ne 2 ]; then
echo "Tool to make clang config files in YAML readable for Doxygen Markdown."
echo "Usage: ./parseYamlToMd.sh <InputFile> <OutputFile>"
	exit 1
fi

# Indent all lines without # or $ (clang-tidy config lines) by four spaces to display them as code block. This must be done specially for doxygen, as clang-tidy cannot read the instructions, otherwise.
sed 's|^[^#$]|    &|' "$1" > "$2"

# Now, remove all comment symbols in the beginning of the lines
sed -i -e 's|^\#||' "$2"

echo "All fine."
