#ifndef SIMPLEPADRESPONSECORRECTIONPROCESSOR_H
#define SIMPLEPADRESPONSECORRECTIONPROCESSOR_H

#include <marlin/Processor.h>
#include <lcio.h>
#include <string>


namespace marlintpc
{
  /** a pad response correction processor
   * simple in the sense, that no track direction is taken into account
   *
   * @author R. Diener, Ch. Rosemann, both DESY
   *
   */

  class SimplePadResponseCorrectionProcessor : public marlin::Processor
  {
    public:

      virtual Processor*  newProcessor()
      {
        return new SimplePadResponseCorrectionProcessor;
      }

      SimplePadResponseCorrectionProcessor();

      virtual void init();

      virtual void processRunHeader(lcio::LCRunHeader* run);

      virtual void processEvent(lcio::LCEvent* evt);

      virtual void check(lcio::LCEvent* evt);

      virtual void end();


    protected:
      /* the place for protected and private member data and functions */
      std::string _inputCollectionName; ///< Name of the input collection -- track seeds
      std::string _outputTrackCollectionName; ///< Name of the output track collection
      bool _outputIsPersistent;  ///< whether the output is to be stored or not (default: true)
  };
} // namespace marlintpc
#endif // SIMPLEPADRESPONSECORRECTIONPROCESSOR_H
