#include "GridPixXrayObject.h"

namespace marlintpc{
  
  std::string GridPixXrayObject::getRevision(){
    return std::string("$Rev: 0042 $");
  }
  
  std::string GridPixXrayObject::getDefaultColName(){
    return std::string("GridPixXrayObjects");
  }
  
  GridPixXrayObject::GridPixXrayObject(){
    setPixels(0);
    setCharge(0);
    setEnergyFromPixels(0.);
    setEnergyFromCharge(0.);
    setLikelihood(0.);
    setCenterX(0.);
    setCenterY(0.);
    setRotAngle(0.);
  }
  
  /*GridPixXrayObject::GridPixXrayObject(GridPixXrayObject* xray){
    setPixels(xray->getPixels());
    setCharge(xray->getCharge());
    setEnergy(xray->getEnergy());
    setLikelihood(xray->getLikelihood());
    setCenterX(xray->getCenterX());
    setCenterY(xray->getCenterY());
    setRotAngle(xray->getRotAngle());    
  }*/
  
  GridPixXrayObject::~GridPixXrayObject(){}
  
  int GridPixXrayObject::getPixels() const {
    return getIntVal(0);
  }
  
  int GridPixXrayObject::getCharge() const {
    return getIntVal(1);
  }
  
  double GridPixXrayObject::getEnergyFromCharge() const {
    return getDoubleVal(0);
  }
  
  double GridPixXrayObject::getEnergyFromPixels() const {
      return getDoubleVal(5);
  }

  double GridPixXrayObject::getLikelihood() const {
    return getDoubleVal(1);
  }
  
  double GridPixXrayObject::getCenterX() const {
    return getDoubleVal(2);
  }
  
  double GridPixXrayObject::getCenterY() const {
    return getDoubleVal(3);
  }
  
  double GridPixXrayObject::getRotAngle() const {
    return getDoubleVal(4);
  }
  
  void GridPixXrayObject::setPixels( int value ) {
    obj()->setIntVal(0, value);
  }
  
  void GridPixXrayObject::setCharge( int value ) {
    obj()->setIntVal(1, value);
  }
  
  void GridPixXrayObject::setEnergyFromCharge( double value ) {
    obj()->setDoubleVal(0, value);
  }
  
  void GridPixXrayObject::setEnergyFromPixels( double value ) {
      obj()->setDoubleVal(5, value);
  }

  void GridPixXrayObject::setLikelihood( double value ) {
    obj()->setDoubleVal(1, value);
  }
  
  void GridPixXrayObject::setCenterX( double value ) {
    obj()->setDoubleVal(2, value);
  }
  
  void GridPixXrayObject::setCenterY( double value ) {
    obj()->setDoubleVal(3, value);
  }
  
  void GridPixXrayObject::setRotAngle( double value ) {
    obj()->setDoubleVal(4, value);
  }

  void GridPixXrayObject::print( std::ostream& os ) const {
    
    os << "Pixels: " << getPixels() << std::endl;
    os << "Charge: " << getCharge() << " electrons" << std::endl;
    os << "EnergyFromCharge: " << getEnergyFromCharge() << " keV" << std::endl;
    os << "EnergyFromPixels: " << getEnergyFromPixels() << " keV" << std::endl;
    os << "Likelihood: " << getLikelihood() << std::endl;
    os << "CenterX: " << getCenterX() << " mm" << std::endl;
    os << "CenterY: " << getCenterY() << " mm" << std::endl;
    os << "RotAngle: " << getRotAngle() << std::endl;
    
  }
  
  std::ostream &operator<<(std::ostream &os, const GridPixXrayObject &xray) {
    xray.print(os);
    return os;
  }

}//namespace marlintpc
