#ifndef STRAIGHT_TRACK_PARAMETERS_H
#define STRAIGHT_TRACK_PARAMETERS_H

#include <TObject.h>
#include <TMatrixD.h>

namespace marlintpc
{
  /** A helper struct to store track parameters for KalTrackingStraight.
   *  It was put into a separate file to be used as a template argument of KalTrackingBase.
   */

  struct StraightTrackParameters
  {
    ///constructor
    StraightTrackParameters();
    
    /// compatibility function for TKalTrack. Always returns a null pointer
    TObject * Last(){ return 0;}

    /// compatibility function for TKalTrack. Does not do anything
    void  SetOwner(Bool_t /*enable*/ = kTRUE){}
    
    TMatrixD _sv; //< Filtered state vector
    TMatrixD _sv1; //< Predicted state vector
    TMatrixD _H; //< Transfer matrix
    TMatrixD _H_t; //< Transpose of H
    TMatrixD _K; //< Kalman gain matrix
    TMatrixD _P; //< Covariance
    TMatrixD _P1; //< Estimated covariance
    TMatrixD _R; //< measurment error matrix
    TMatrixD _M_unit; //<  A 2*2 unit matrix
    double _deltaChi2; //< The current Chi2 increment
    double _chi2; //< The total one
  };

}// namespace marlintpc

#endif // STRAIGHT_TRACK_PARAMETERS_H
