#ifndef TPCHITDOMAIN_H 
#define TPCHITDOMAIN_H

#include <TMatrixD.h>
#include <TVector3.h>
#include <kaltest/TKalDetCradle.h>
#include <kaltest/TKalTrack.h>
#include <kaltest/TVKalDetector.h>
#include <kaldet/GearTPCKalDetector.h>
#include <kaldet/GearTPCMeasLayer.h>
#include "KalTrackingBase.h"
#include "TPCHitMap.h"

namespace marlintpc
{

class TPCHitDomain{

    public:
        TPCHitDomain(TKalDetCradle const * kalDetCradle, 
		     kaldet::GearTPCKalDetector const * kalDetector, 
		     gear::TPCParameters const * tpcParameters);

        std::set< std::pair<int, int> > getModuleRows(TVector3 const & extrapolatedHitPosition) const;
		std::set< std::pair<int, int> > getModuleRows( int moduleID, int row) const;


    protected:
        TKalDetCradle const * _kalDetCradle; //< A pointer for the cradle with all the Kalman layers

	kaldet::GearTPCKalDetector const *  _kalDetector; //< A pointer to the KalDetector

		gear::TPCParameters const * _tpcParameters; //< A pointer to the gear geometry

        std::set< std::pair<int, int> > _moduleRows;

        int _referencePosition;
        int _currentPosition;
        int _skip;
        int _maxSkip;

		int _direction; //< Either forward or backward
};

}
#endif  //TPCHITDOMAIN_H
