#include "StraightTrackParameters.h"

namespace marlintpc
{

StraightTrackParameters::StraightTrackParameters():
    _sv(2, 1), _sv1(2, 1), _H(1, 2), _H_t(2, 1),
    _K(2, 1), _P(2, 2), _P1(2, 2), _R(1, 1), _M_unit(2, 2), _deltaChi2(0.0), _chi2(0.0)
{
    const double P1_init[4] = {1.0e10, 0, 0, 1.0e10};
    const double sv1_init[2] = {0, 0};
    const double PHI_init[4] = {1, 0, 0, 1};

    _P1(0, 0) = P1_init[0];
    _P1(0, 1) = P1_init[1];
    _P1(1, 0) = P1_init[2];
    _P1(1, 1) = P1_init[3];

    _sv1(0, 0) = sv1_init[0];
    _sv1(1, 0) = sv1_init[1];

    _M_unit(0, 0) = PHI_init[0];
    _M_unit(0, 1) = PHI_init[1];
    _M_unit(1, 0) = PHI_init[2];
    _M_unit(1, 1) = PHI_init[3];

    _H[0][1] = 1;
    _H_t[1][0] = 1;

    _R(0, 0) = 0.4;
}

}// namespace marlintpc
