/*
 * DataFormatDecoder.hh
 *
 *  Created on: Jul 11, 2012
 *      Author: caiazza
 */

#ifndef DATAFORMATDECODER_HH_
#define DATAFORMATDECODER_HH_

#include <stdint.h>
#include <vector>

//LCIO
#include "lcio.h"
#include "EVENT/LCCollection.h"

namespace marlintpc
{
/**
 * Interface class for the ALTRO data decoder
 */
class DataFormatDecoder
{
public:
    virtual ~DataFormatDecoder(){}

    virtual void AddData(lcio::LCCollection* Collection) const = 0;

};

/**
 * Implementation of the decoder for dataformat 1
 */
class DataFormatDecoder_V1: public DataFormatDecoder
{
public:
    DataFormatDecoder_V1(std::vector<uint32_t>::iterator& BeginData, uint32_t RCUID);

    virtual ~DataFormatDecoder_V1();

    virtual void AddData(lcio::LCCollection* Collection) const;

private:
    std::vector<uint32_t>::const_iterator _beginData;

    uint32_t _RCUID;

    static const uint32_t WORDID = 0xC0000000;
    static const uint32_t ERRORBIT = 0x20000000;
    static const uint32_t CHANNELHEADER = 0x1FFFFFFF;
    static const uint32_t DWNUM = 0x0003FF0000;
    static const uint32_t CHANNELADDRESS = 0x00000FFF;
    static const uint32_t DW1 = 0x000003FF;
    static const uint32_t DW2 = 0x000FFC00;
    static const uint32_t DW3 = 0x3FF00000;
};

}


#endif /* DATAFORMAT1DECODER_HH_ */
