/*
 * TEORBlock_V47.cpp
 *
 *  Created on: Nov 14, 2012
 *      Author: amunnich
 */

#include "TIEORBlock.hh"
#include <string>
#include <sstream>
#include <iostream>

namespace marlintpc
{
TEORBlock_V47::TEORBlock_V47(std::vector<uint32_t>& Content):
        TEORBlock_V42(Content)
{
    if(!CheckIntegrity())
    {
        std::stringstream message;
        message << "Failed integrity check while analyzing the End of run Block" << std::endl;
        
        throw TAltroConverterDecodeException("TEORBlock_V47", message.str());
    }
}

TEORBlock_V47::~TEORBlock_V47()
{

}



lcio::LCTime
TEORBlock_V47::GetEndTime() const
{
  std::vector<uint32_t> BlockContent = TEORBlock_V42::Content(); 
  UTIL::LCTime time(static_cast<int>(BlockContent[6]));
  time +=  BlockContent[7];
  // std::cout<<"RUNEND: "<<time.timeStamp()<<" "<<time.getDateString()<<std::endl;
  return time;   
}



}//end namespace

