/*
 * CORBlock.hh
 *
 *  Created on: Jul 26, 2011
 *      Author: caiazza
 */

#ifndef CORBLOCK_HH_
#define CORBLOCK_HH_

#include "AltroBlocksLib.h"

namespace A2Lconverter
{
class CORBlock : public AltroBlock
{

public:
    /**
     * From stream constructor that works as a default as well
     */
    CORBlock(std::ifstream* const inputFile=0);
    CORBlock(std::ifstream* const inputFile, int start_address,
            uint32_t length = 0);

    /**
     * Construct the derived class from an instance of the mother class
     */
    CORBlock(const AltroBlock & theMotherBlock);

    /**
     * Construct the class from the data vector
     */
    CORBlock(const std::vector<uint32_t> & refContent);

    /**
     * Destructor
     */
    virtual ~CORBlock()
    {
    }

    /**
     * Derived class implementation of the decode function
     */
    virtual void
    Decode();

    /**
     * Derived class implementation of the writer function
     */
    virtual void
    Write2LCIO(IO::LCWriter* lcwriter) const {}

    /**
     * Derived class implementation of the printer function
     */
    virtual std::string
    PrintSummary() const;

    /**
     * Derived class implementation of the Check Integrity function
     */
    virtual bool
    CheckIntegrity() const;

protected:
    uint32_t lastEventN;
};
}




#endif /* CORBLOCK_HH_ */
