#ifndef CYLINDRICAL2DMAGNETICFIELDMAP_H
#define CYLINDRICAL2DMAGNETICFIELDMAP_H

// stl
#include <string>
#include <vector>

#include "Cylindrical2DMagneticField.h"

// gear
#include "gear/BField.h"
#include "gearimpl/GearParametersImpl.h"

// lcio
#include "EVENT/LCIO.h"

namespace marlintpc
{

    /** Cylindrical2DMagneticFieldMap : A magnetic field from a cylindrical 2d field map (r and z)
     *
     *    @author Ch. Rosemann, DESY; based on work by Christian Grefe <br>
     *    !! note the namespace !!
     */
    class Cylindrical2DMagneticFieldMap : public gear::GearParametersImpl, public gear::BField
    {

        public:
            /** constructor
             */
            Cylindrical2DMagneticFieldMap();

            void init(double, double, double, double, double);

            /** destructor
             */
            virtual ~Cylindrical2DMagneticFieldMap();

            bool updateMagneticField(EVENT::LCCollection *);

            virtual gear::Vector3D at(gear::Vector3D point) const;

        private:

            Cylindrical2DMagneticField* _theImplementation;
    };

} // namespace marlintpc

#endif // CYLINDRICAL2DMAGNETICFIELDMAP_H
