#ifdef USE_CGA

// stl
#include <string>
#include <cassert>

// Marlin
#include <marlin/Global.h>

// GEAR
#include <gear/BField.h>
#include <gearimpl/Vector3D.h>

// Mokka
#include <CGADefs.h>

// LCIO
#include <EVENT/LCCollection.h>
#include <EVENT/LCGenericObject.h>
#include <EVENT/LCRunHeader.h>

// marlintpc
#include "CGAElectricField.h"
#include "CGAMagneticField.h"

using namespace CLHEP;
using namespace EVENT;
using namespace std;
using namespace gear;

namespace marlintpc {

	
/** constructor
 */
  CGAElectricField::CGAElectricField ( lcio::LCRunHeader *run_header ):
	Field("CGAElectricField") {

	if( !CGAMagneticField::_cga_initialized ) {

		CGAInit( run_header->parameters().getStringVal("MOKKA_SteeringFile").c_str(), "", "", "", "", "" );

		CGAMagneticField::_cga_initialized = true;
	}
}


/** destructor
 */
CGAElectricField::~CGAElectricField() {}


/** returns a new field... similar to how the Marlin processor registration works
*/
Field *CGAElectricField::new_field( void ) { return 0; }


/** constructs the field from an LCCollection of data objects (could be anything... field bin values or just parameters)
*/
  bool CGAElectricField::construct( lcio::LCCollection *collection ) {

	return true;
}


/** gets the field value at a specified point
*/
Hep3Vector CGAElectricField::get_field_value( const Hep3Vector &position ) {

 double the_exact_same_position[3];
	the_exact_same_position[0] = position[0];
	the_exact_same_position[1] = position[1];
	the_exact_same_position[2] = position[2];

	// calculate B and E (E is constant for now)
	const vector< double > E = CGAGetE( the_exact_same_position );

	Hep3Vector field_vector ( E[0], E[1], E[2] );

	return field_vector;
}

} // namespace marlintpc

#endif // USE_CGA
