#include "Cylindrical2DMagneticFieldMap.h"

using namespace std;
using namespace gear;

namespace marlintpc
{

    /** constructor
     */
    Cylindrical2DMagneticFieldMap::Cylindrical2DMagneticFieldMap()
    {
        _theImplementation = new Cylindrical2DMagneticField();
    }

    void    Cylindrical2DMagneticFieldMap::init(double cX, double cY, double cZ, double crotX, double crotY)
    {
        if(_theImplementation)
            _theImplementation->init(cX, cY, cZ, crotX, crotY);
    }




    /** destructor
     */
    Cylindrical2DMagneticFieldMap::~Cylindrical2DMagneticFieldMap()
    {
        if(_theImplementation)
            delete _theImplementation;
    }



    bool Cylindrical2DMagneticFieldMap::updateMagneticField(EVENT::LCCollection* collection)
    {
        if(_theImplementation)
            return _theImplementation->construct(collection);
        else
            return false;
    }




    Vector3D Cylindrical2DMagneticFieldMap::at(Vector3D point) const
    {
        const CLHEP::Hep3Vector vec(point.x(), point.y(), point.z());
        CLHEP::Hep3Vector val = _theImplementation->get_field_value(vec);
        const Vector3D retval(val.x(), val.y(), val.z());
        return retval;
    }

} // namespace marlintpc
