// marlintpc
#include "UnitBiDirectionalElectricField.h"

// stl
#include <string>
#include <cassert>

// Marlin
#include <marlin/Global.h>

// GEAR
#include <gearimpl/Vector3D.h>

// LCIO
#include <EVENT/LCCollection.h>
#include <EVENT/LCGenericObject.h>
#include <EVENT/LCRunHeader.h>


using namespace CLHEP;
using namespace EVENT;
using namespace std;
using namespace gear;

namespace marlintpc {

// create one to register it with the global field processor
UnitBiDirectionalElectricField aUnitBiDirectionalElectricField;


/** constructor
 */
UnitBiDirectionalElectricField::UnitBiDirectionalElectricField ( ):
	Field("UnitBiDirectionalElectricField") {

}


/** destructor
 */
UnitBiDirectionalElectricField::~UnitBiDirectionalElectricField() {}


/** returns a new field... similar to how the Marlin processor registration works
*/
Field *UnitBiDirectionalElectricField::new_field( void ) { return new UnitBiDirectionalElectricField(); }


/** constructs the field from an LCCollection of data objects (could be anything... field bin values or just parameters)
*/
bool UnitBiDirectionalElectricField::construct( LCCollection * /*collection*/ ) {

	return true;
}


/** gets the field value at a specified point
*/
Hep3Vector UnitBiDirectionalElectricField::get_field_value( const Hep3Vector &position ) {

	if ( position.z() > 0 ) {

		return Hep3Vector ( 0., 0., 1. );
	}
	else {

		return Hep3Vector ( 0., 0., -1. );
	}
}

} // namespace marlintpc
