#ifndef PADGEOMETRYCHECKER_H
#define PADGEOMETRYCHECKER_H

#include <marlin/Processor.h>
#include <lcio.h>
#include <string>

/** PadGeometryCheckerProcessor: take the xml gear geometry file and print out simple stuff about the pad layout; basically completely copoied from the HepRepOutput by J. Abernathy
    @author Ch. Rosemann, DESY
 */
class PadGeometryChecker : public marlin::Processor 
{
 public:
  PadGeometryChecker();
  virtual ~PadGeometryChecker();
  
  Processor * newProcessor();

  void init();
  void processRunHeader (lcio::LCRunHeader *run);
  virtual void processEvent(lcio::LCEvent *evt);
  virtual void check (lcio::LCEvent *evt);
  virtual void end();

 private:
  std::string _outfileName;
};

#endif // PADGEOMETRYCHECKER_H
