#ifndef DRAWMAGNETICFIELDPROCESSOR_H
#define DRAWMAGNETICFIELDPROCESSOR_H

#include <marlin/Processor.h>
#include <lcio.h>
#include <string>
#include <vector>
#include "TGraph2D.h"


namespace marlintpc
{
/*
 * This processor draws plots of the Br and Bz components of the active magnetic fields.
 * It is meant as an example to the usage of magnetic fields in MarlinTPC.
 *
 * @author Christian Grefe
 */
class DrawMagneticFieldProcessor : public marlin::Processor
{
 public:
  
  virtual Processor*  newProcessor() { return new DrawMagneticFieldProcessor; }
  
  DrawMagneticFieldProcessor();
  
  virtual void init();
  
  virtual void processEvent(lcio::LCEvent* evt);
  
  
 protected:
  bool _draw;
  double _xMin;
  double _xMax;
  double _zMin;
  double _zMax;
  int _xBins;
  int _zBins;

 private:
  void styleHist(TGraph2D* g, std::string title, std::string xTitle, std::string yTitle, std::string zTitle);

};
} // namespace marlintpc
#endif // DRAWMAGNETICFIELDPROCESSOR_H
