#ifndef DUMP_PAD_CENTRES_PROCESSOR_H
#define DUMP_PAD_CENTRES_PROCESSOR_H 1

//LCIO
#include <lcio.h>

//MARLIN
#include <marlin/Processor.h>

//GEAR
#include <gear/PadRowLayout2D.h>

namespace marlintpc
{

    /** Dump the coordinates of pad centres of pads correcponding to pulses.
     *  This is easier to read than the output of dumpevent.
     *
     *  @author Martin Killenberg, University of Bonn
     */
    class DumpPadCentresProcessor : public marlin::Processor{
			      
    public:
    
	virtual Processor*  newProcessor() { return new DumpPadCentresProcessor ; }
    
	DumpPadCentresProcessor();

	virtual void init() ;
	virtual void processEvent( LCEvent * evt ) ; 
    
    protected:

     std::string _inputColName ;    ///< the name of the input collection
     gear::PadRowLayout2D const *_padLayout;

    };
}

#endif // DUMP_PAD_CENTRES_PROCESSOR_H
