#include "TPCGas.h"
#include <iostream>
#include "stdlib.h"

using namespace std;
using namespace marlintpc;

int main(int argc, char **argv)
{

  if (argc==4)
    {
      string gasName=argv[1];
      TPCGas *gas=new TPCGas(gasName);
      gas->SetEField(atof(argv[3]));
      gas->SetBField(atof(argv[2]));
      gas->CalculateGasParameters();
      cout<<atof(argv[2])<<" "<<atof(argv[3])<<" "<<gas->GetDriftVelocity()<<" "
	  << gas->GetTransverseDiffusion()<<"  "
	  <<gas->GetLongitudinalDiffusion()<<" "
	  <<gas->GetAttachment(atof(argv[3]),0.2)<<endl;;
    }
 
  
  if (argc!=2)
    {
      std::cout<<"Usage: testTPCGas gasName (available TDR,P5,P10,T2K)"<<std::endl;
      return(1);
    }
  
  string gasName=argv[1];
  TPCGas *gas=new TPCGas(gasName);
  cout<<"#GAS="<<gas->GetGasName()<<endl;
  //scan E field
  for(int B=0;B<5;B++)
    {
      for(int E=10;E<100000;E=E*2)
	{
	  gas->SetEField(E);
	  gas->SetBField(B);
	  gas->CalculateGasParameters();
	  cout<<B<<" "<<E<<" "<<gas->GetDriftVelocity()<<" "
	      << gas->GetTransverseDiffusion()<<"  "
	      <<gas->GetLongitudinalDiffusion()<<" "
	      <<gas->GetAttachment(E,0.2)<<endl;;

	}
    }


}
